//
// by Khlytin Grigoriy, 06.11.2022
//

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long int ll;

bool check(ll a, ll b, ll k, ll m, set<pair<ll, ll>> &ans) {
    // =====
    // (A + 1) * (B + 1) = m
    // A + B = k
    // A < a
    // B < b
    // A <= k
    // B <= k
    // =====

    for (ll B = max(0LL, k - a + 1LL); B < min(b, k + 1LL); B++) {
        ll A = k - B;
        if ((A + 1LL) * (B + 1LL) == m) {
            ans.insert({A, B});
        }
    }

    return (!ans.empty());
}

int main() {
    ll t;
    cin >> t;

    for (ll i = 0LL; i < t; i++) {
        ll a, b, k, m;
        set<pair<ll, ll>> ans;
        cin >> a >> b >> k >> m;
        if (check(a, b, k, m, ans)) {
            pair<ll, ll> p = *ans.begin();
            cout << p.first << " " << p.second << "\n";
        } else {
            cout << -1 << "\n";
        }
    }

    return 0;
}
