#include "testlib.h"

using namespace std;

int const K = 10'000;
int const N = 100'000;
int const A = 1'000'000'000;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group().size() ? atoi(validator.group().c_str()) : -1;
    int klim = K, nlim = N, alim = A;
    switch (group) {
        case 1:
            klim = 1, nlim = 10, alim = 10;
            break;
        case 2:
            klim = 10, nlim = 10, alim = 100;
            break;
        case 3:
            klim = 1000, nlim = 1000, alim = 1;
            break;
        case 5:
            klim = 1, nlim = 1000;
            break;
        case 6:
            nlim = 1000;
            break;
        case 7:
            klim = 1;
            break;
    }

    int k = inf.readInt(1, K, "k");
    inf.readSpace();
    int n = inf.readInt(1, N, "n");
    inf.readEoln();

    ensuref(k <= klim, "Group %d condition k <= %d unsatisfied", group, klim);
    ensuref(n <= nlim, "Group %d condition n <= %d unsatisfied", group, nlim);

    for (int i = 0; i < n; i++) {
        inf.readToken("[NSWE]", format("d_%d", i + 1));
        inf.readSpace();
        int a = inf.readInt(1, A, format("a_%d", i + 1));
        inf.readEoln();

        ensuref(a <= alim, "Group %d condition a_%d <= %d unsatisfied", group, i + 1, alim);
        if (group == 4) {
            ensuref(a == k, "Group 4 condition a_%d = k unsatisfied", i + 1);
        }
    }

    inf.readEof();

}