using namespace std;

#include "testlib.h"

using ull = unsigned long long;

const ull max_b_ab = 10'000;
const ull max_b_z = 1'000'000'000;
const ull max_b_p = 1'000'000'000'000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    ull max_p = has_opt("p") ? opt<ull>("p") : max_b_p;
    ull max_ab = has_opt("a") ? opt<ull>("a") : max_b_ab;
    ull max_z = has_opt("z") ? opt<ull>("z") : max_b_z;

    int n = max_n == 1 ? 1 : (1 + rnd.wnext(max_n, 5));
    ull p = 1 + rnd.wnext(max_p, 10);
    printf("%d %llu\n", n, p);

    for (int i = 0; i < n; ++i) {
        ull z = rnd.next(1ULL, max_z);
        ull a = rnd.next(1ULL, max_ab);
        ull b = rnd.next(1ULL, max_ab);
        printf("%llu %llu %llu\n", z, a, b);
    }
}

