#include "testlib.h"
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const int MAXN = 100'000, MAXQ = 100'000;
vector<int> maxN = { 300, 300, 3'000, 50'000, 100'000, 100'000, 100'000, 100'000 };
vector<int> maxQ = { 10, 300, 100'000, 10, 100'000, 100'000, 100'000, 100'000 };

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());

    int n = inf.readInt(2, maxN[group], "n");
    inf.readSpace();
    int q = inf.readInt(1, maxQ[group], "q");
    inf.readEoln();

    vector<int> perm;
    set<int> st;
    for (int i = 0; i < n; i++) {
        int h = inf.readInt(1, n, "perm");
        st.insert(h);
        perm.push_back(h);
        if (i != n - 1) inf.readSpace();
        
        if (group == 4) ensuref(perm[i] == i + 1, "values must increase");
    }

    ensuref(st.size() == n, "participants must be given a permutation");

    inf.readEoln();

    set<int> uniqp, uniqk;
    for (int i = 0; i < q; i++) {
        int p = inf.readInt(1, n, "p");
        inf.readSpace();
        int k = inf.readInt(1, n, "k");
        inf.readEoln();
        
        uniqp.insert(p);
        uniqk.insert(k);
    }
    
    if (group == 5) ensuref(uniqk.size() == 1, "k must be unique");
    if (group == 6) ensuref(uniqp.size() == 1, "p must be unique");

    inf.readEof();
}
