#include <iostream>
#include <vector>
#include <algorithm>
 
using namespace std;
 
#define fastInp ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
 
typedef long long ll;
typedef long double ld;
 
const ll N = 1e5, INF = 1e9 + 1000;
 
pair<ll, ll> seg[N * 4];
vector<ll> perm;
 
void upd(int v, int l, int r, int pos, int val) {
	if (l == r - 1) {
		seg[v] = { val, pos };
	} else {
		int mid = (l + r) / 2;
 
		if (pos < mid) {
			upd(v * 2 + 1, l, mid, pos, val);
		} else {
			upd(v * 2 + 2, mid, r, pos, val);
		}
 
		seg[v] = max(seg[v * 2 + 1], seg[v * 2 + 2]);
	}
}
 
pair<ll, ll> ask(int v, int l, int r, int askl, int askr) {
	if (l >= askr || r <= askl) return {};
 
	if (askl <= l && r <= askr) return seg[v];
 
	int mid = (l + r) / 2;
	return max(ask(v * 2 + 1, l, mid, askl, askr), ask(v * 2 + 2, mid, r, askl, askr));
}
 
vector<pair<ll, ll>> ask(int n, int askl, int askr) {
	vector<pair<ll, ll>> mx = { ask(0, 0, n, askl, askr) };
 
	ll p = mx[0].second;
 
	mx.push_back({ -INF, -INF });
	if (askl != p) {
		mx.back() = max(mx.back(), ask(0, 0, n, askl, p));
	}
	if (p + 1 != askr) {
		mx.back() = max(mx.back(), ask(0, 0, n, p + 1, askr));
	}
 
	if (mx.back().first == -INF) mx.pop_back();
	return mx;
}
 
int main() {
	fastInp;
 
	ll n, q;
	cin >> n >> q;
 
	perm.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> perm[i];
		upd(0, 0, n, i, perm[i]);
	}
 
	while (q--) {
		ll t = 1;
 
		if (t == 1) {
			ll p, k;
			cin >> p >> k;
            
            if (k == 1) {
                cout << "1\n";
                continue;
            }
			p--;
 
			ll ans = 0;
 
			// [p, p + k)
			if (p + k <= n) {
				vector<pair<ll, ll>> mx = ask(n, p, p + k);
 
				if (p + k == n || mx[0].first < perm[p + k]) {
					ans += (p + k) - mx[0].second - 1;
				}
 
				/*if (mx[1].second < mx[0].second && (p + k == n || mx[1].first < perm[p + k])) {
					ans++;
				}*/
			}
 
			// [p - k + 1, p + 1)
			if (p - k + 1 >= 0) {
				vector<pair<ll, ll>> mx = ask(n, p - k + 1, p + 1);
 
				if (p - k < 0 || mx[0].first < perm[p - k]) {
					ans += mx[0].second - (p - k + 1);
				}
 
				if (mx[0].second < mx[1].second && (p - k < 0 || mx[1].first < perm[p - k])) {
					ans++;
				}
			}
 
			cout << ans << "\n";
		} else {
			ll u, v;
			cin >> u >> v;
			u--; v--;
			swap(perm[u], perm[v]);
 
			upd(0, 0, n, u, perm[u]);
			upd(0, 0, n, u, perm[v]);
		}
	}
 
	return 0;
}
