#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define fastInp ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

const ll N = 1e5;

vector<pair<ll, ll>> seg[N * 4];
vector<ll> perm;

vector<pair<ll, ll>> mrg(const vector<pair<ll, ll>>& a, const vector<pair<ll, ll>>& b) {
	vector<pair<ll, ll>> res;
	merge(a.begin(), a.end(), b.begin(), b.end(), back_inserter(res));

	while (res.size() > 2) res.pop_back();

	return res;
}

void upd(int v, int l, int r, int pos, int val) {
	if (l == r - 1) {
		if (seg[v].size() != 0) seg[v].pop_back();

		seg[v].push_back({ -val, pos });
	} else {
		int mid = (l + r) / 2;

		if (pos < mid) {
			upd(v * 2 + 1, l, mid, pos, val);
		} else {
			upd(v * 2 + 2, mid, r, pos, val);
		}

		seg[v] = mrg(seg[v * 2 + 1], seg[v * 2 + 2]);
	}
}

vector<pair<ll, ll>> ask(int v, int l, int r, int askl, int askr) {
	if (l >= askr || r <= askl) return {};

	if (askl <= l && r <= askr) return seg[v];

	int mid = (l + r) / 2;
	return mrg(ask(v * 2 + 1, l, mid, askl, askr), ask(v * 2 + 2, mid, r, askl, askr));
}

int main() {
	fastInp;

	ll n, q;
	cin >> n >> q;

	perm.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> perm[i];
		upd(0, 0, n, i, perm[i]);
	}

	while (q--) {
		ll t = 1;

		if (t == 1) {
			ll p, k;
			cin >> p >> k;
            
            if (k == 1) {
                cout << "1\n";
                continue;
            }
			p--;

			ll ans = 0;

			// [p, p + k)
			if (p + k <= n) {
				vector<pair<ll, ll>> mx = ask(0, 0, n, p, p + k);
				for (auto& c : mx) c.first *= (-1);

				if (p + k == n || mx[0].first < perm[p + k]) {
					ans += (p + k) - mx[0].second - 1;
				}

				if (mx[1].second < mx[0].second && (p + k == n || mx[1].first < perm[p + k])) {
					ans++;
				}
			}

			// [p - k + 1, p + 1)
			if (p - k + 1 >= 0) {
				vector<pair<ll, ll>> mx = ask(0, 0, n, p - k + 1, p + 1);
				for (auto& c : mx) c.first *= (-1);

				if (p - k < 0 || mx[0].first < perm[p - k]) {
					ans += mx[0].second - (p - k + 1);
				}

				if (mx[0].second < mx[1].second && (p - k < 0 || mx[1].first < perm[p - k])) {
					ans++;
				}
			}

			cout << ans << "\n";
		} else {
			ll u, v;
			cin >> u >> v;
			u--; v--;
			swap(perm[u], perm[v]);

			upd(0, 0, n, u, perm[u]);
			upd(0, 0, n, u, perm[v]);
		}
	}

	return 0;
}
