#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;

const int MOD = 1e9+7;
const int N = 1e6;

array<int, 9> get_pair_count(const string& s) {
    array<int, 9> res;
    fill(res.begin(), res.end(), 0);

    for (int i = 0; i + 1 < (int)s.size(); ++i) {
        res[3*(s[i] - 'a') + s[i+1] - 'a']++;
    }

    return res;
}

bool check(const array<int, 9> m) {
    vector<int> deg(3);

    for (int i = 0; i < 3; ++i)
    for (int j = 0; j < 3; ++j) {
        deg[i] += m[3*i+j];
        deg[j] -= m[3*i+j];
    }

    if (deg[0] + deg[1] + deg[2] != 0) return false;

    if (abs(deg[0]) > 1) return false;
    if (abs(deg[1]) > 1) return false;
    if (abs(deg[2]) > 1) return false;

    if (deg[0]) return deg[1] == 0 || deg[2] == 0;
    if (deg[1]) return deg[0] == 0 || deg[2] == 0;
    if (deg[2]) return deg[0] == 0 || deg[1] == 0;
    return true;
}

void brute(array<int, 9>& m, int& out, int cur) {
    if (!check(m)) return;

    int sm = 0;
    for (int i : m) sm += i;
    if (sm == 0) {
        out++;
    } else {
        vector<char> used(3);
        used[cur] = 1;
        for (int i = 0; i < 3; ++i) if (m[cur*3+i]) used[i] = 1;
        for (int i = 0; i < 3; ++i)
        for (int j = 0; j < 3; ++j) if (m[3*i+j] && used[i]) used[j] = 1;

        for (int i = 0; i < 3; ++i) {
            if (!used[i] && m[4*i]) return;
        }

        for (int i = 0; i < 3; ++i) {
            if (m[3*cur+i] <= 0) continue;

            m[3*cur+i]--;
            brute(m, out, i);
            m[3*cur+i]++;
        }
    }
}

int get_count_slow(array<int, 9> m) {
    int ans = 0;
    for (int i = 0; i < 3; ++i) {
        string st(1, 'a' + i);
        brute(m, ans, i);
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    
    int g; cin >> g;

    int q; cin >> q;
    while (q--) {
        string s; cin >> s;
        auto m = get_pair_count(s);
        int res = get_count_slow(m);
        cout << res << '\n';
    }
}