#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int MOD = 1e9+7;
const int N = 1e6;

int fact[N+1], rfct[N+1];

int rev(int a, int m = MOD) {
    return a == 1 ? 1 : m - (ll)m*rev(m%a, a)/a;
}

int C(int n, int k) {
    if (k < 0 || k > n) return 0;
    if (n < 0) return 0;
    return (ll)fact[n]*rfct[k]%MOD*rfct[n-k]%MOD;
}

int Balls(int n, int k) {
    if (k == 0) return 1;
    return C(n+k-1, k);
}

int solve(const std::string& s) {
    if (s.size() == 1) return 3;

    int c_ab = 0, c_ba = 0, c_a = 0, c_b = 0;
    for (size_t i = 0; i + 1 < s.size(); ++i) {
        if (s[i] == 'a' && s[i+1] == 'b') ++c_ab;
        if (s[i] == 'b' && s[i+1] == 'a') ++c_ba;
        if (s[i] == 'a' && s[i+1] == 'a') ++c_a;
        if (s[i] == 'b' && s[i+1] == 'b') ++c_b;
    }

    ll res = 0;
    for (int t = 2; t--; ) {
        if (c_ab == c_ba) {
            const int block_A = c_ab + 1;
            const int block_B = c_ab;
            res += (ll) Balls(block_A, c_a) * Balls(block_B, c_b);
        } else if (c_ab == c_ba + 1) {
            const int block_A = c_ab;
            const int block_B = c_ab;
            res += (ll) Balls(block_A, c_a) * Balls(block_B, c_b);
        }

        swap(c_ab, c_ba);
        swap(c_a, c_b);
    }

    return res % MOD;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    fact[0] = 1;
    for (int i = 1; i <= N; ++i) fact[i] = (ll)fact[i-1]*i%MOD;
    rfct[N] = rev(fact[N]);
    for (int i = N; i >= 1; --i) rfct[i-1] = (ll)rfct[i]*i%MOD;

    int g; cin >> g;
    if (g != 1) return 0;

    int q; cin >> q;
    while (q--) {
        string s; cin >> s;
        int ans = solve(s);
        cout << ans << '\n';
    }
}
